#!/usr/bin/perl -w

use strict;

my $dhcpfile = '/etc/dhcpd/dhcpd.conf';
my $mysqlfile = '/tmp/mysqldhcpdata';
my $verbose = 0;
my $arg = shift;
$verbose = 1 if $arg && $arg eq '-d';

# first update dhcp config
system ('cd /etc/dhcpd; make');

open (DHCP, $dhcpfile) or die "Cannot read $dhcpfile: $!\n";
open (MYSQL, ">$mysqlfile") or die "Unable to write $mysqlfile: $!\n";

my $dhcp;
while (<DHCP>) {
	chomp;
	s/^\s+//;	# strip leading whitespace
	s/#.*$//;	# strip comments
	s/(\s+)/ /g;	# reduce whitespace
	next if /^\s*$/;# strip blank lines
	$dhcp .= $_;
	# ferret out host definitions
	if ($dhcp =~ s/(host .*{.*})//) {
		parse_host ($1);
	}
}

sub parse_host {
	my ($hostbit) = @_;
	my ($dhcpname, $brace) = $hostbit =~ /^host (\S+)\s*{(.*)}$/
		or die "$hostbit didn't parse\n";
	$brace =~ tr/A-Z/a-z/;	#translate to lower case;
	my ($host) = $brace =~ /fixed-address (\S+)\s*;/;
	my ($mac) = $brace =~ /hardware ethernet (\S+)\s*;/;
	unless ($host && $mac) {
		print "something odd about '$brace'\n" if $verbose;
		return;
	}
	print MYSQL "$dhcpname,$mac,$host\n";
}
close (DHCP);
close (MYSQL);

my $create = 'create table if not exists dhcpdata ('.
'dhcpname varchar (30), mac char(17), dhcphostname varchar(30))';

my $cmd = "/usr/bin/mysql -s -e '$create' arpwatch";
print $cmd, "\n" if $verbose;
system ($cmd);

$cmd = "/usr/bin/mysql -s -e 'delete from dhcpdata; load data infile \"$mysqlfile\" into table dhcpdata fields terminated by \",\"' arpwatch";
print $cmd, "\n" if $verbose;
system ($cmd);

unlink ($mysqlfile);

exit 1;
